lf4rcs.config.git = {

  render_draft_reference = function(url, draft)
    if not draft.external_reference then return end
    ui.tag{ content = _"Changeset:" }
    slot.put(" ")
    ui.link{
      text = draft.external_reference,
      external = url .. ";a=commit;h=" .. draft.external_reference
    }
  end,

  get_remote_user = function()
    return os.getenv("REMOTE_USER")
  end,

  get_branches = function(path, exec)
    local branches = {}
    for line in io.lines() do
      local oldrev, newrev, branch = string.match(line, "([^ ]+) ([^ ]+) refs/heads/(.+)")
      if not branch then
        return nil, "unexpected format from git hook environment"
      end
      branches[branch] = { newrev }
    end
    return branches
  end,

  commit = function(path, exec, branch, target_node_id, close_message, merge_message)
    if merge_message then
      exec("git", "-C", path, "checkout", "master")
      exec("git", "-C", path, "merge", target_node_id, "-m", merge_message)
      exec("git", "-C", path, "push", "origin", "master")
    end
  end

}
